import { AlignEdge } from '../../common/alignment';
import { CSSProperties } from 'react';
import { StoryContext } from '@storybook/addons';
declare type FlexConfig = {
    flexDirection?: CSSProperties['flexDirection'];
    justifyContent?: CSSProperties['justifyContent'];
    alignItems?: CSSProperties['alignItems'];
    flexWrap?: CSSProperties['flexWrap'];
    alignContent?: CSSProperties['alignContent'];
};
export interface IHostOptions {
    title?: string;
    hr?: boolean;
    padding?: number | string | number[];
    align?: AlignEdge;
    width?: number | string;
    height?: number | string;
    maxWidth?: number | string;
    background?: string | number | boolean;
    backdrop?: string | number | boolean;
    cropMarks?: boolean;
    border?: string | number | boolean;
    styles?: any;
    flex?: boolean | FlexConfig;
}
export interface IComponentHostProps {
    story: (context: StoryContext) => any;
    context: StoryContext;
    options: IHostOptions;
    parameters: IHostOptions;
}
export declare const ComponentHost: (props: IComponentHostProps) => JSX.Element;
export {};
