"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var common_1 = require("../../common");
var AlignmentContainer_1 = require("../AlignmentContainer");
var CropMarks_1 = require("../CropMarks");
var RED = 'rgba(255, 0, 0, 0.1)';
exports.ComponentHost = function (props) {
    var combinedOptions = __assign({}, props.options, props.parameters, { flex: (function () {
            if (props.parameters.flex === false) {
                return false;
            }
            if (isObject(props.options.flex) || isObject(props.parameters.flex)) {
                return __assign({}, (isObject(props.options.flex) ? props.options.flex : {}), (isObject(props.parameters.flex) ? props.parameters.flex : {}));
            }
            else if (props.options.flex || props.parameters.flex) {
                return true;
            }
            return false;
        })() });
    var title = combinedOptions.title, align = combinedOptions.align, width = combinedOptions.width, height = combinedOptions.height, maxWidth = combinedOptions.maxWidth, _a = combinedOptions.padding, padding = _a === void 0 ? 50 : _a, background = combinedOptions.background, _b = combinedOptions.backdrop, backdrop = _b === void 0 ? 'white' : _b, _c = combinedOptions.cropMarks, cropMarks = _c === void 0 ? true : _c, _d = combinedOptions.border, border = _d === void 0 ? 0 : _d, flex = combinedOptions.flex;
    var story = props.story;
    var hr = combinedOptions.hr;
    hr = hr === false ? false : true;
    var componentBackground = formatColor(background);
    var backdropColor = common_1.color.create(formatColor(backdrop));
    var isBackdropDark = isDark(backdropColor);
    var cropMarkColor = isBackdropDark
        ? 'rgba(255, 255, 255, 0.3)'
        : 'rgba(0, 0, 0, 0.1)';
    var titleColor = isBackdropDark
        ? 'rgba(255, 255, 255, 0.7)'
        : 'rgba(0, 0, 0, 0.6)';
    var componentBorder = border;
    if (common_1.R.is(Number, border)) {
        componentBorder = "solid 1px " + common_1.color.toGrayAlpha(border);
    }
    if (border === true) {
        componentBorder = "dashed 1px rgba(0, 0, 0, 0.2)";
    }
    var styles = {
        base: common_1.css({
            Absolute: 0,
            display: 'flex',
            flexDirection: 'column',
            background: backdropColor.toRgbString(),
        }),
        normalizeText: common_1.css({
            fontFamily: 'sans-serif',
            lineHeight: 1.15,
            msTextSizeAdjust: '100%',
            WebkitTextSizeAdjust: '100%',
        }),
        header: common_1.css({
            borderBottom: hr ? "solid 1px " + cropMarkColor : undefined,
            paddingTop: 2,
            paddingBottom: hr ? 15 : undefined,
            marginLeft: 15,
            marginTop: 15,
            marginRight: 15,
        }),
        h2: common_1.css({
            fontWeight: 200,
            fontSize: 20,
            padding: 0,
            margin: 0,
            color: titleColor,
        }),
        body: common_1.css({
            boxSizing: 'border-box',
            position: 'relative',
            flex: 1,
            margin: formatMarginPadding(padding),
        }),
    };
    var flexStyle = (function () {
        if (!flex) {
            return {};
        }
        if (flex === true) {
            return {
                display: 'flex',
            };
        }
        return __assign({ display: 'flex' }, flex);
    })();
    return (common_1.React.createElement("div", __assign({}, common_1.css(styles.base, styles.normalizeText)),
        title && (common_1.React.createElement("div", __assign({}, styles.header),
            common_1.React.createElement("h2", __assign({}, styles.h2), title))),
        combinedOptions.styles,
        common_1.React.createElement("div", __assign({}, styles.body),
            common_1.React.createElement(AlignmentContainer_1.AlignmentContainer, { align: align },
                common_1.React.createElement(CropMarks_1.CropMarks, { width: width, height: height, maxWidth: maxWidth, background: componentBackground, cropMarkColor: cropMarkColor, cropMarksVisible: cropMarks, border: componentBorder, style: flexStyle }, story(props.context))))));
};
function formatColor(value) {
    if (value === undefined) {
        return;
    }
    if (common_1.R.is(Number, value)) {
        return common_1.color.toGrayHex(value);
    }
    if (value === true) {
        return RED;
    }
    return value;
}
function isDark(color) {
    return color.getAlpha() < 0.4 ? false : color.getBrightness() < 130;
}
function formatMarginPadding(value) {
    if (common_1.R.is(Array, value)) {
        return value
            .slice(0, 4)
            .map(function (n) { return n + "px"; })
            .join(' ');
    }
    return value;
}
function isObject(value) {
    return value !== null && typeof value === 'object';
}
//# sourceMappingURL=ComponentHost.js.map